# Ogre::FileStreamDataStream Class Reference

Common subclass of DataStream for handling data from std::basic_istream. More...

`#include <OgreDataStream.h>`

Inheritance diagram for Ogre::FileStreamDataStream:

List of all members.

## Public Member Functions

| FileStreamDataStream (std::ifstream *s, bool freeOnClose=true)
| Construct stream from an STL stream.
| FileStreamDataStream (const String &name, std::ifstream *s, bool freeOnClose=true)
| Construct named stream from an STL stream.
| FileStreamDataStream (const String &name, std::ifstream *s, size_t size, bool freeOnClose=true)
| Construct named stream from an STL stream, and tell it the size.
| ~FileStreamDataStream ()
size_t | read (void *buf, size_t count)

Parameters:

  buf | Reference to a buffer pointer
  count | Number of bytes to read

Returns:
  The number of bytes read

size_t | readLine (char *buf, size_t maxCount, const String &delim="\n")

Remarks:
  The delimiter character is not included in the data returned, and it is skipped over so the next read will occur after it. The buffer contents will include a terminating character.

Parameters:

  buf | Reference to a buffer pointer
  maxCount | The maximum length of data to be read, excluding the terminating character
  delim | The delimiter to stop at

Returns:
  The number of bytes read, excluding the terminating character

size_t | skipLine (const String &delim="\n")

Parameters:

  delim | The delimiter(s) to stop at

Returns:
  The number of bytes skipped

void | skip (long count)
| This can also be a negative value, in which case the file pointer rewinds a defined number of bytes.
void | seek (size_t pos)
size_t | tell (void) const
bool | eof (void) const
void | close (void)
const String & | getName (void)
| Returns the name of the stream, if it has one.
template<typename T> DataStream & | operator>> (T &val)
virtual String | getLine (bool trimAfter=true)
| Returns a String containing the next line of data, optionally trimmed for whitespace.
virtual String | getAsString (void)
| Returns a String containing the entire stream.
size_t | size (void) const
| Returns the total size of the data to be read from the stream, or 0 if this is indeterminate for this stream.

## Protected Attributes

std::ifstream * | mpStream
| Reference to source stream.
bool | mFreeOnClose
String | mName
| The name (e.g. resource name) that can be used to identify the source fot his data (optional).
size_t | mSize
| Size of the data in the stream (may be 0 if size cannot be determined).
char | mTmpArea [OGRE_STREAM_TEMP_SIZE]
| Temporary buffer area used for formatted read.

## Detailed Description

Common subclass of DataStream for handling data from std::basic_istream.

Definition at line 311 of file OgreDataStream.h.

## Constructor & Destructor Documentation

Ogre::FileStreamDataStream::FileStreamDataStream | ( | std::ifstream * | s,
|  | bool | freeOnClose = true
| ) |

Construct stream from an STL stream.

Parameters:

  s | Pointer to source stream
  freeOnClose | Whether to delete the underlying stream on destruction of this class

Ogre::FileStreamDataStream::FileStreamDataStream | ( | const String & | name,
|  | std::ifstream * | s,
|  | bool | freeOnClose = true
| ) |

Construct named stream from an STL stream.

Parameters:

  name | The name to give this stream
  s | Pointer to source stream
  freeOnClose | Whether to delete the underlying stream on destruction of this class

Ogre::FileStreamDataStream::FileStreamDataStream | ( | const String & | name,
|  | std::ifstream * | s,
|  | size_t | size,
|  | bool | freeOnClose = true
| ) |

Construct named stream from an STL stream, and tell it the size.

Remarks:
  This variant tells the class the size of the stream too, which means this class does not need to seek to the end of the stream to determine the size up-front. This can be beneficial if you have metadata about the contents of the stream already.

Parameters:

  name | The name to give this stream
  s | Pointer to source stream
  size | Size of the stream contents in bytes
  freeOnClose | Whether to delete the underlying stream on destruction of this class

Ogre::FileStreamDataStream::~FileStreamDataStream | ( |  | ) |

## Member Function Documentation

void Ogre::FileStreamDataStream::close | ( | void |  | ) | `[virtual]`

| Implements Ogre::DataStream.

bool Ogre::FileStreamDataStream::eof | ( | void |  | ) | const`[virtual]`

| Implements Ogre::DataStream.

virtual String Ogre::DataStream::getAsString | ( | void |  | ) | `[virtual, inherited]`

Returns a String containing the entire stream.

Remarks:
  This is a convenience method for text streams only, allowing you to retrieve a String object containing all the data in the stream.

virtual String Ogre::DataStream::getLine | ( | bool | trimAfter = true | ) | `[virtual, inherited]`

Returns a String containing the next line of data, optionally trimmed for whitespace.

Remarks:
  This is a convenience method for text streams only, allowing you to retrieve a String object containing the next line of data. The data is read up to the next newline character and the result trimmed if required.

Parameters:

  trimAfter | If true, the line is trimmed for whitespace (as in String.trim(true,true))

const String& Ogre::DataStream::getName | ( | void |  | ) | `[inherited]`

| Returns the name of the stream, if it has one. Definition at line 70 of file OgreDataStream.h. References Ogre::String.

template<typename T>
DataStream& Ogre::DataStream::operator>> | ( | T & | val | ) | `[inherited]`

size_t Ogre::FileStreamDataStream::read | ( | void * | buf,
|  | size_t | count
| ) | `[virtual]`

Parameters:

  buf | Reference to a buffer pointer
  count | Number of bytes to read

Returns:
  The number of bytes read

Implements Ogre::DataStream.

size_t Ogre::FileStreamDataStream::readLine | ( | char * | buf,
|  | size_t | maxCount,
|  | const String & | delim = "\n"
| ) | `[virtual]`

Remarks:
  The delimiter character is not included in the data returned, and it is skipped over so the next read will occur after it. The buffer contents will include a terminating character.

Parameters:

  buf | Reference to a buffer pointer
  maxCount | The maximum length of data to be read, excluding the terminating character
  delim | The delimiter to stop at

Returns:
  The number of bytes read, excluding the terminating character

Implements Ogre::DataStream.

void Ogre::FileStreamDataStream::seek | ( | size_t | pos | ) | `[virtual]`

| Implements Ogre::DataStream.

size_t Ogre::DataStream::size | ( | void |  | ) | const`[inherited]`

| Returns the total size of the data to be read from the stream, or 0 if this is indeterminate for this stream. Definition at line 138 of file OgreDataStream.h.

void Ogre::FileStreamDataStream::skip | ( | long | count | ) | `[virtual]`

| This can also be a negative value, in which case the file pointer rewinds a defined number of bytes. Implements Ogre::DataStream.

size_t Ogre::FileStreamDataStream::skipLine | ( | const String & | delim = "\n" | ) | `[virtual]`

Parameters:

  delim | The delimiter(s) to stop at

Returns:
  The number of bytes skipped

Implements Ogre::DataStream.

size_t Ogre::FileStreamDataStream::tell | ( | void |  | ) | const`[virtual]`

| Implements Ogre::DataStream.

## Member Data Documentation

bool Ogre::FileStreamDataStream::mFreeOnClose `[protected]`

| Definition at line 316 of file OgreDataStream.h.

String Ogre::DataStream::mName `[protected, inherited]`

| The name (e.g. resource name) that can be used to identify the source fot his data (optional). Definition at line 58 of file OgreDataStream.h.

std::ifstream* Ogre::FileStreamDataStream::mpStream `[protected]`

| Reference to source stream. Definition at line 315 of file OgreDataStream.h.

size_t Ogre::DataStream::mSize `[protected, inherited]`

| Size of the data in the stream (may be 0 if size cannot be determined). Definition at line 60 of file OgreDataStream.h.

char Ogre::DataStream::mTmpArea[OGRE_STREAM_TEMP_SIZE]`[protected, inherited]`

| Temporary buffer area used for formatted read. Definition at line 63 of file OgreDataStream.h.

The documentation for this class was generated from the following file:

- OgreDataStream.h

Copyright © 2000-2005 by The OGRE Team
This work is licensed under a Creative Commons Attribution-ShareAlike 2.5 License.
Last modified Sun Feb 12 13:00:19 2006